"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MdkLocalException = void 0;
const MdkErrorMessages_1 = require("./MdkErrorMessages");
class MdkLocalException {
    /*    static readonly CONFIG_MISSING: string = "MA01";
        static readonly CONFIG_VALUE_INVALID: string = "MA02";
        static readonly FILE_NO_EXIST: string = "MA03";
        static readonly ENCRYPTION_ERROR: string = "MA04";
        static readonly DECRYPTION_ERROR: string = "MA06";*/
    static TYPE_A_INTERNAL_ERROR = "MA99";
    /*    static readonly NO_CONFIG_FILE: string = "MB01";
        static readonly CONFIG_READ_ERROR: string = "MB02";*/
    static SOCKET_FACTORY_CREATION_ERROR = "MB03";
    static TYPE_B_INTERNAL_ERROR = "MB99";
    /*    static readonly PROXY_CONNECT_ERROR: string = "MF01";*/
    static GW_CONNECT_ERROR = "MF02";
    static SERVER_TIMEOUT = "MF03";
    static SOCKET_IO_ERROR = "MF04";
    static INTERNAL_SERVER_ERROR = "MF05";
    static BAD_GW = "MF06";
    static SERVICE_UNAVAILABLE = "MF07";
    static TYPE_F_INTERNAL_ERROR = "MF99";
    _logger;
    _error = undefined;
    _errorCode;
    _errorMessage;
    constructor(logger, errorCode, replaceStr = undefined, error = undefined) {
        this._logger = logger;
        this._error = error;
        this._errorCode = errorCode;
        this._errorMessage = this.getErrorMessage(errorCode, replaceStr);
    }
    get errorMessage() {
        return this._errorMessage;
    }
    get errorCode() {
        return this._errorCode;
    }
    getErrorMessage(errorCode, replaceStr) {
        let errorMessage = MdkErrorMessages_1.MdkErrorMessages.getValue(errorCode, replaceStr);
        if (this._error == null) {
            this._logger.error(errorMessage);
        }
        else {
            this._logger.error(errorMessage, this._error);
        }
        return errorMessage;
    }
}
exports.MdkLocalException = MdkLocalException;
//# sourceMappingURL=MdkLocalException.js.map